﻿using Newtonsoft.Json.Linq;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using static MxWDB.JSON.AHDump;

namespace MxWDB.JSON
{
    internal class AHDump
    {
        public class Item
        {
            public int id { get; set; }
        }

        public class RootAuctions
        {
            public int id { get; set; }
            public Item item { get; set; }
            public int quantity { get; set; }
            public Int64 unit_price { get; set; }
            public Int64 buyout { get; set; }
            public string time_left { get; set; }
        }

        public static DataSet aucds = new DataSet();
        public static DataSet aucdscom = new DataSet();

        public static void GenTable()
        {
            /*
            var jf = File.ReadAllText(string.Format("{0}_{1}-dump.json", Server.region, Server.realm));
            var root = JObject.Parse(jf).SelectToken("auctions").ToString();
            File.WriteAllText("root.json", root);
            DataSet ds = JsonConvert.DeserializeObject<DataSet>(root);
            DataTable table = ds.Tables["auctions"];

            DataTable auctb = new DataTable("auclist");

            auctb.Columns.Add(new DataColumn("auc", typeof(Int64)));
            auctb.Columns.Add(new DataColumn("item", typeof(Int64)));
            auctb.Columns.Add(new DataColumn("owner", typeof(string)));
            auctb.Columns.Add(new DataColumn("value", typeof(Int64)));
            auctb.Columns.Add(new DataColumn("qty", typeof(int)));
            auctb.Columns.Add(new DataColumn("time", typeof(string)));

            foreach (DataRow dr in table.Rows)
            {               
                Int64 buy = Convert.ToInt64(dr["buyout"]);

                if (buy > 0)
                {
                    DataRow nr = auctb.NewRow();

                    nr["auc"] = Convert.ToInt32(dr["auc"]);
                    nr["item"] = Convert.ToInt32(dr["item"]);
                    nr["owner"] = dr["owner"];
                    nr["qty"] = Convert.ToInt32(dr["quantity"]);

                    int qty = Convert.ToInt32(dr["quantity"]);

                    if (qty == 1)
                    {
                        nr["value"] = buy;
                    }
                    else
                    {
                        nr["value"] = buy / qty;
                    }

                    auctb.Rows.Add(nr);
                }               
            }
            aucds.Tables.Add(auctb);
            */

            var jf = File.ReadAllText(string.Format("json/ah.dump.json"));
            var root = JObject.Parse(jf).SelectToken("auctions").ToString();
            var RootAuctions = JsonConvert.DeserializeObject<List<RootAuctions>>(root);

            DataTable auctb = new DataTable("auclist");

            auctb.Columns.Add(new DataColumn("aid", typeof(int)));
            auctb.Columns.Add(new DataColumn("iid", typeof(int)));
            auctb.Columns.Add(new DataColumn("qty", typeof(int)));
            auctb.Columns.Add(new DataColumn("uv", typeof(Int64)));

            foreach (var r in RootAuctions)
            {
                DataRow nr = auctb.NewRow();

                /*if (!Utilities.DB.CheckItemInfoExists(r.item.id))
                {
                    Utilities.DB.GenItemInfo(r.item.id);
                }*/

                nr["aid"] = r.id;
                nr["iid"] = r.item.id;
                nr["qty"] = r.quantity;
                if (r.unit_price > 0)
                {
                    nr["uv"] = r.unit_price;
                }
                if (r.buyout > 0)
                {
                    nr["uv"] = r.buyout;
                }

                auctb.Rows.Add(nr);
            }

            aucds.Tables.Add(auctb);
        }

        public static void GenTableCom()
        {
            /*
            var jf = File.ReadAllText(string.Format("{0}_{1}-dump.json", Server.region, Server.realm));
            var root = JObject.Parse(jf).SelectToken("auctions").ToString();
            File.WriteAllText("root.json", root);
            DataSet ds = JsonConvert.DeserializeObject<DataSet>(root);
            DataTable table = ds.Tables["auctions"];

            DataTable auctb = new DataTable("auclist");

            auctb.Columns.Add(new DataColumn("auc", typeof(Int64)));
            auctb.Columns.Add(new DataColumn("item", typeof(Int64)));
            auctb.Columns.Add(new DataColumn("owner", typeof(string)));
            auctb.Columns.Add(new DataColumn("value", typeof(Int64)));
            auctb.Columns.Add(new DataColumn("qty", typeof(int)));
            auctb.Columns.Add(new DataColumn("time", typeof(string)));

            foreach (DataRow dr in table.Rows)
            {               
                Int64 buy = Convert.ToInt64(dr["buyout"]);

                if (buy > 0)
                {
                    DataRow nr = auctb.NewRow();

                    nr["auc"] = Convert.ToInt32(dr["auc"]);
                    nr["item"] = Convert.ToInt32(dr["item"]);
                    nr["owner"] = dr["owner"];
                    nr["qty"] = Convert.ToInt32(dr["quantity"]);

                    int qty = Convert.ToInt32(dr["quantity"]);

                    if (qty == 1)
                    {
                        nr["value"] = buy;
                    }
                    else
                    {
                        nr["value"] = buy / qty;
                    }

                    auctb.Rows.Add(nr);
                }               
            }
            aucds.Tables.Add(auctb);
            */

            var jf = File.ReadAllText(string.Format("json/ah.com.dump.json"));
            var root = JObject.Parse(jf).SelectToken("auctions").ToString();
            var RootAuctions = JsonConvert.DeserializeObject<List<RootAuctions>>(root);

            DataTable auctbcom = new DataTable("auclistcom");

            auctbcom.Columns.Add(new DataColumn("aid", typeof(int)));
            auctbcom.Columns.Add(new DataColumn("iid", typeof(int)));
            auctbcom.Columns.Add(new DataColumn("qty", typeof(int)));
            auctbcom.Columns.Add(new DataColumn("uv", typeof(Int64)));

            foreach (var r in RootAuctions)
            {
                DataRow nr = auctbcom.NewRow();
                nr["aid"] = r.id;
                nr["iid"] = r.item.id;
                nr["qty"] = r.quantity;
                nr["uv"] = r.unit_price;

                auctbcom.Rows.Add(nr);
            }

            aucdscom.Tables.Add(auctbcom);
        }
    }
}
