﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MxWDB.JSON
{
    internal class Settings
    {
        public class SETTINGS
        {
            public string apikey { get; set; }
            public string apisecret { get; set; }
            public string region { get; set; }
            public int realmid { get; set; }
            public string dbname { get; set; }
            public string dbhost { get; set; }
            public string dbport { get; set; }
            public string dbuser { get; set; }
            public string dbpass { get; set; }
            public bool debug { get; set; }
        }

        ///<summary>
        ///Load the Database Host from the Settings Json.
        ///</summary>
        public static string GetDBHost() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("json/settings.json")).dbhost;
        ///<summary>
        ///Load the Database Port from the Settings Json.
        ///</summary>
        public static string GetDBPort() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("json/settings.json")).dbport;
        ///<summary>
        ///Load the Database Name from the Settings Json.
        ///</summary>
        public static string GetDBName() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("json/settings.json")).dbname;
        ///<summary>
        ///Load the Database User from the Settings Json.
        ///</summary>
        public static string GetDBUser() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("json/settings.json")).dbuser;
        ///<summary>
        ///Load the Database Password from the Settings Json.
        ///</summary>
        public static string GetDBPass() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("json/settings.json")).dbpass;
        ///<summary>
        ///Load the Blizzard Dev API Key from the Settings Json.
        ///</summary>
        public static string GetAPIKey() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("json/settings.json")).apikey;
        ///<summary>
        ///Load the Blizzard Dev API Secret from the Settings Json.
        ///</summary>
        public static string GetAPISecret() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("json/settings.json")).apisecret;
        ///<summary>
        ///Load the Realm Region from the Settings Json.
        ///</summary>
        public static string GetRegion() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("json/settings.json")).region;
        ///<summary>
        ///Load the Realm ID from the Settings Json.
        ///</summary>
        public static int GetRID() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("json/settings.json")).realmid;
        ///<summary>
        ///Used for developper. So far, it prevent the software from downloading a new dump, saving a lot of time for testing.
        ///</summary>
        public static bool GetDebug() => JsonConvert.DeserializeObject<SETTINGS>(File.ReadAllText("json/settings.json")).debug;
    }
}
