﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MxWDB.Utilities
{
    internal class IO
    {
        /// <summary>
        /// Create a directory at the specified path.
        /// </summary>
        /// <param name="path">The path where to create a new directory.</param>
        /// <returns></returns>
        public static void CreateDirectory(string path)
        {
            Directory.CreateDirectory(path);
        }

        ///<summary>
        ///Check by manipulating/scanning the disk if MxWDB is ran for the first time.
        ///</summary>
        public static bool FirstRun()
        {
            if (Directory.Exists("json"))
            {
                return false;
            } else
            {
                return true;
            }
        }

        ///<summary>
        ///Check if the settings json is valid.
        ///</summary>
        public static bool SettingsValid()
        {
            if (JSON.Settings.GetAPIKey() == "" || JSON.Settings.GetAPISecret() == "" || JSON.Settings.GetRegion() == "" || JSON.Settings.GetRID() == 0 || JSON.Settings.GetDBName() == "" || JSON.Settings.GetDBHost() == "" || JSON.Settings.GetDBPort() == "" || JSON.Settings.GetDBName() == "" || JSON.Settings.GetDBUser() == "" || JSON.Settings.GetDBPass() == "")
            {
                return false;
            }
            else
            {
                return true;
            }
        }

        /// <summary>
        /// Check if a file has been correctly downloaded.
        /// </summary>
        /// <param name="path">The path to the file.</param>
        /// <returns></returns>
        public static bool FileIsDownloaded(string path)
        {           
            if (File.Exists(path))
            {
                long lenght = new FileInfo(path).Length;
                if (lenght > 0) 
                {
                    return true;
                } else
                {
                    return false;
                }
            }
            else
            {
                return false;
            }
        }
    }
}
